using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace Virtual_Paging
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.gridControl1.DefaultColWidth = 70;
            this.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid;
            this.gridControl1.DefaultRowHeight = 18;
            this.gridControl1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridControl1.Location = new System.Drawing.Point(0, 0);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.Size = new System.Drawing.Size(758, 242);
            this.gridControl1.SmartSizeBox = false;
            this.gridControl1.TabIndex = 0;
            this.gridControl1.Text = "gridControl1";
            this.gridControl1.VerticalScrollTips = true;
            this.gridControl1.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(this.gridControl1_QueryColCount);
            this.gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(this.gridControl1_QueryCellInfo);
            this.gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(this.gridControl1_QueryRowCount);
            this.gridControl1.ScrollTipFeedback += new Syncfusion.Windows.Forms.ScrollTipFeedbackEventHandler(this.gridControl1_ScrollTipFeedback);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(758, 242);
            this.Controls.Add(this.gridControl1);
            this.Name = "Form1";
            this.Text = "Virtual_Paging...";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private DataStore myData = null;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.myData = new DataStore(200, 1000000, 10,this.gridControl1);			
			this.myData.EnsureDataAvailable(0); // load page containing position 0
			this.gridControl1.ResetVolatileData();
            //this.gridControl1.ColWidths[0] = 60;
        }

        # region   [    Virtual Events...     ]
        // Please refer to our documentation for more details on Virtual events ...
        private void gridControl1_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			if(this.myData == null || this.myData.RowCount == 0)
				return;

			e.Count = this.myData.AbsColCount;
			e.Handled = true;
		}

		private void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			if(this.myData == null || this.myData.RowCount == 0)
				return;

			e.Count = this.myData.AbsRowCount;
			e.Handled = true;
		}

		private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(e.RowIndex > 0 && e.ColIndex > 0)
			{
				if(this.myData == null || this.myData.RowCount == 0)
					return;
				
				if(this.myData.EnsureDataAvailable(e.RowIndex))
				{
					int rowPos = e.RowIndex - this.gridControl1.Rows.HeaderCount - this.myData.StartRow;
					int colPos = e.ColIndex - this.gridControl1.Cols.HeaderCount - 1;
					e.Style.CellValue = this.myData.ActiveTable.Rows[rowPos][colPos];
					e.Style.BackColor = this.myData.ActiveTableColor;
				}
			}
        }
        # endregion        

		private void gridControl1_ScrollTipFeedback(object sender, Syncfusion.Windows.Forms.ScrollTipFeedbackEventArgs e)
		{
			e.Size = this.gridControl1.ScrollTip.GetPreferredSize(e.Text);
		}		 
	}	
}
